<?php

namespace STM\DB\SQL;

use \Exception;
use \ReflectionClass;
use STM\Utils\Strings;

/**
 * Test class for JoinTable.
 * Generated by PHPUnit on 2012-02-11 at 12:20:21.
 * @group database
 */
class JoinTableTest extends \PHPUnit_Framework_TestCase {

    public function testValid_join_tables() {
        foreach ($this->get_join_types() as $type) {
            $join = $this->getInstance($type, DT_COMPETITIONS, 'comp.id = team.id');
            parent::assertTrue($join->isValid());
            parent::assertTrue(Strings::isStringNonEmpty($join->getTable()));
            parent::assertTrue(Strings::isStringNonEmpty($join->__toString()));
        }
    }

    public function testCross_join() {
        // for cross join 3rd argument dont have to be set (it is not controlled)
        $invalid_values = array('', array(), new Exception(), false, null);
        foreach ($invalid_values as $bad_value) {
            $join = $this->getInstance(JoinType::CROSS, DT_COMPETITIONS, $bad_value);
            parent::assertTrue($join->isValid());
            $join = $this->getInstance(JoinType::JOIN, DT_COMPETITIONS, $bad_value);
            parent::assertFalse($join->isValid());
        }
    }

    public function testInvalid_join_tables() {
        foreach ($this->get_join_types() as $type) {
            $invalid_values = array('', array(), new Exception(), false, null);
            foreach ($invalid_values as $bad_value) {
                $join = $this->getInstance($type, $bad_value, $bad_value);
                parent::assertFalse($join->isValid());
                parent::assertFalse(Strings::isStringNonEmpty($join->getTable()));
                parent::assertFalse(Strings::isStringNonEmpty($join->__toString()));
            }
        }
    }

    private function getInstance($type, $table, $condition) {
        return new JoinTable($type, $table, $condition);
    }

    private function get_join_types() {
        $join_types = new ReflectionClass('\STM\DB\SQL\JoinType');
        return $join_types->getConstants();
    }

}

?>
